package org.zeroturnaround.javarebel.integration.servlet.weblogic;

import org.zeroturnaround.bundled.javassist.CannotCompileException;
import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.expr.ConstructorCall;
import org.zeroturnaround.bundled.javassist.expr.ExprEditor;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.servlet.jsp.JavelinxTagFileStaleChecker<code>.
 * <p>
 * Thanks to Sylvain Laurent. 
 * 
 * @author Rein Raudjärv
 */
public class JavelinxTagFileStaleCheckerCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    /*
     * Do not create a new JspClassLoader 
     */
    ctClass.getDeclaredMethod("isClassStale").instrument(new ExprEditor() {
      public void edit(ConstructorCall c) throws CannotCompileException {
        if (c.getClassName().equals("weblogic.servlet.jsp.JspClassLoader"))
          c.replace("{ $_ = $2; }");
      }
    });
  }

}
